/*
Lexmark 1100 printer driver for Linux
Copyright (C) 1999   Tim Engler

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

// stores all the information to paint a single brush stroke of the printer head(used by LexmarkProtocol)
#include "PaintLineBW.h"
#include <string.h>
#include <stdio.h>

PaintLineBW::PaintLineBW(int x, int y, int size)
{
    this->size = size;
	this->x = x;
	this->y = y;

    data = (char *)memset(new char [size*7],0,size*7);
}

PaintLineBW::~PaintLineBW()
{
	delete [] data;
}

//paints a droplet of paint
void PaintLineBW::paint(int sx,int x, int nozzle, int color)
{
	int index = x - sx;
	int byte = nozzle / 8;
    data[byte + index * 7] |= 1 << (7 - nozzle % 8);
}

