/*
Lexmark 1100 printer driver for Linux
Copyright (C) 1999   Tim Engler

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#include "errors.h"
#include "SpongeWriter.h"


SpongeWriter::SpongeWriter(int maxSize, int fd)
{
	this->fd = fd;
	this->buffer = new ThreadSafeCircleBuffer(maxSize);
	this->valid = true;

	pthread_create(&this->thread,NULL,&writeBuffer,this);
}

SpongeWriter::~SpongeWriter()
{
	valid = false;
	//buffers deconstructor handles thread synchronization problems
	delete this->buffer;
	if(firstWrite == false) // if consumer thread was created
		pthread_join(this->thread, NULL);
}


void SpongeWriter::write(char *data, int length)
{
	// buffer the data
	buffer->put(data,length);
	
}



void *writeBuffer(void *arg)
{
	SpongeWriter *sp = (SpongeWriter *)arg;

	sp->buffer->get(sp->fd);
	
	return NULL;
}

